// ---------------------------------------------------------------------------
// fire_on_my_target.cs -- Version 1.7 -- October 28, 2000
// by Lorne Laliberte (writer@planetstarsiege.com)
//
// Automatically say "Fire on my target!" when you fire the targeting laser
//
// http://www.writerscripts.com
// ---------------------------------------------------------------------------

include("writer\\version.cs");
version("writer\\fire_on_my_target.cs", "1.7", "Lorne Laliberte", "Oct 28, 2000");

include("writer\\event.cs");
include("writer\\fire.cs");
include("writer\\flood.cs");
include("writer\\inventory.cs");
include("writer\\save.cs");
include("writer\\whatif.cs");

// ---------------------------------------------------------------------------
// DEFAULT SETTINGS:
//
// Edit these if you're running this script for the first time
// All subsequent settings must be done in the config\wp_fire_on_my_target.cs file

    // Enable the automatic "Fire on my target!" message by default
    $FireOnMyTarget::Enabled = "false";

    // Key that you can hold to override the above $FireOnMyTarget::enabled
    // setting -- I recommend using a modifier like "lshift"
    $FireOnMyTarget::OverrideKey = "";

    // Toggle the automatic "Fire on my target" message
    //bind(keyboard0, make, l_alt, "t", to, "FireOnMyTarget::Toggle();");
    //bind(keyboard0, break, l_alt, "t", to, "", "FireOnMyTarget::Toggle_break");

// ---------------------------------------------------------------------------

WriterPrefs::load("fire_on_my_target");

// Automatically say "Fire on my target" when you fire the targeting laser
// unless you already said that in the last 15 seconds :)
//
function AutoMessage::FireOnMyTarget(%weapon)
{
	if(%weapon == $Inv::Targeting_Laser)
	{
        if($FireOnMyTarget::Enabled)
        {
    		if(Flood::Protect(FireOnMyTarget, 15))
    			say(1, "Fire on my target~wfiretgt");
        }
	}
}


function FireOnMyTarget::Toggle()
{
    remoteBP(2048, "<L5>Automatically say <f1>\"Fire on my target\" <f2>" @ wif($FireOnMyTarget::Enabled = !$FireOnMyTarget::Enabled, "ON", "OFF"), 4);
}

function fire_on_my_target::save()
{
    AddExportText("    // Enable the automatic \"Fire on my target!\" message by default");
    ExportSetting("    $FireOnMyTarget::Enabled", false);
    AddExportText("");
    AddExportText("    // Key that you can hold to override the above $FireOnMyTarget::enabled");
    AddExportText("    // setting -- I recommend using a modifier like \"lshift\"");
    ExportSetting("    $FireOnMyTarget::OverrideKey", "");
    AddExportText("");
    AddExportText("    // Toggle the automatic \"Fire on my target\" message");

    ExportBind("FireOnMyTarget::Toggle();", "//bind(keyboard0, make, alt, \"f\", TO, \"FireOnMyTarget::Toggle();\");");
    ExportBind("FireOnMyTarget::Toggle_break", "//bind(keyboard0, break, alt, \"f\", TO, \"\", FireOnMyTarget::Toggle_break);");
}

WriterPrefs::save("fire_on_my_target");

function fire_on_my_target::init()
{
    needs("writer\\fire_on_my_target.cs", "writer\\event.cs 2.7",
                                          "writer\\inventory.cs 3.3",
                                          "writer\\fire.cs 3.0",
                                          "writer\\flood.cs 1.3",
                                          "writer\\save.cs 2.3",
                                          "writer\\whatif.cs 1.1");

    if(String::Compare($FireOnMyTarget::OverrideKey, "")) // $FireOnMyTarget::OverrideKey != ""
    {
        Modifier::bind($FireOnMyTarget::OverrideKey);
        Event::Attach("modifier" @ $FireOnMyTarget::OverrideKey @ Pressed, "$FireOnMyTarget::Enabled = !$FireOnMyTarget::Enabled;");
        Event::Attach("modifier" @ $FireOnMyTarget::OverrideKey @ Released, "$FireOnMyTarget::Enabled = !$FireOnMyTarget::Enabled;");
    }

    Event::Attach(eventFirePressed, AutoMessage::FireOnMyTarget);
}
Event::Attach(writerInit, "fire_on_my_target::init();");

if(!$UsingWriterLoader) fire_on_my_target::init();
